/* config-manager.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

public class Valide.ConfigManager : AbstractConfigManager
{
  private static ConfigManager instance;
  private const string CONFIG_FILE_ = "config.ini";

  public override string config_file
  {
    owned get
    {
      return this.create_file (this.CONFIG_FILE_, """[GtkSourceView]
indent-width=2
auto-indent=true
indent-on-tab=true
tab-width=4
highlight-current-line=true
show-right-margin=true
right-margin-position=80
show-line-numbers=false
insert-spaces-instead-of-tabs=true

[Plugins]
Todo=true
Symbol=true

[SymbolBrowser]
show-language=false
show-source-file=false
show-line-number=false
hierarchic-view=true
""");
    }
  }

  private ConfigManager ()
  {
  }

  protected override void first_run ()
  {
    DirUtils.create (Path.build_filename (this.home, "plugins"), 0700);
    DirUtils.create (Path.build_filename (this.home, "template"), 0700);
  }

  public static ConfigManager get_instance ()
  {
    if (instance == null)
    {
      instance = new ConfigManager ();
    }
    return instance;
  }

  public override void preferences ()
  {
    PreferencesDialog dialog = new PreferencesDialog ();
    dialog.run ();
    dialog.destroy ();
  }
}

