/* template-manager.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

public class Valide.TemplateManager : Object
{
  private static TemplateManager instance = null;

  private TemplateManager ()
  {
  }

  public static TemplateManager get_instance ()
  {
    if (TemplateManager.instance == null)
    {
      TemplateManager.instance = new TemplateManager ();
    }
    return TemplateManager.instance;
  }

  public List<string> get_list ()
  {
    string[] template_dir = { Path.build_filename (Config.PACKAGE_DATA_DIR, "template"),
                              Path.build_filename (ConfigManager.get_instance ().home,
                                                   "template")
                            };

    List<string> list = new List<string> ();

    foreach (string d in template_dir)
    {
      try
      {
        Dir dir = Dir.open (d);

        do
        {
          string filename = dir.read_name ();

          if (filename != null)
          {
            if (FileUtils.test (Path.build_filename (d, filename), FileTest.IS_DIR))
            {
              string file = Path.build_filename (d, filename, "template.xml");
              if (FileUtils.test (file, FileTest.EXISTS))
              {
                list.append (file);
              }
            }
          }
          else
          {
            break;
          }
        } while (true);
      }
      catch (Error e)
      {
        debug (e.message);
      }
    }
    list.first ();
    return list;
  }
}

