/* compiler.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __LIBVALIDE_COMPILER_H__
#define __LIBVALIDE_COMPILER_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <libvalide/abstract-executable.h>
#include <libvalide/executable-manager.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_COMPILER (valide_compiler_get_type ())
#define VALIDE_COMPILER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_COMPILER, ValideCompiler))
#define VALIDE_COMPILER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_COMPILER, ValideCompilerClass))
#define VALIDE_IS_COMPILER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_COMPILER))
#define VALIDE_IS_COMPILER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_COMPILER))
#define VALIDE_COMPILER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_COMPILER, ValideCompilerClass))

typedef struct _ValideCompiler ValideCompiler;
typedef struct _ValideCompilerClass ValideCompilerClass;
typedef struct _ValideCompilerPrivate ValideCompilerPrivate;

typedef enum  {
	VALIDE_ERROR_PARSING_FILE,
	VALIDE_ERROR_PARSING_LINE
} ValideErrorParsing;
#define VALIDE_ERROR_PARSING valide_error_parsing_quark ()
struct _ValideCompiler {
	ValideAbstractExecutable parent_instance;
	ValideCompilerPrivate * priv;
};

struct _ValideCompilerClass {
	ValideAbstractExecutableClass parent_class;
};


GQuark valide_error_parsing_quark (void);
ValideCompiler* valide_compiler_construct (GType object_type);
ValideCompiler* valide_compiler_new (void);
GType valide_compiler_get_type (void);


G_END_DECLS

#endif
