/* goto-dialog.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __LIBVALIDE_GOTO_DIALOG_H__
#define __LIBVALIDE_GOTO_DIALOG_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <libvalide/abstract-text-document.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_GOTO_DIALOG (valide_goto_dialog_get_type ())
#define VALIDE_GOTO_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_GOTO_DIALOG, ValideGotoDialog))
#define VALIDE_GOTO_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_GOTO_DIALOG, ValideGotoDialogClass))
#define VALIDE_IS_GOTO_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_GOTO_DIALOG))
#define VALIDE_IS_GOTO_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_GOTO_DIALOG))
#define VALIDE_GOTO_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_GOTO_DIALOG, ValideGotoDialogClass))

typedef struct _ValideGotoDialog ValideGotoDialog;
typedef struct _ValideGotoDialogClass ValideGotoDialogClass;
typedef struct _ValideGotoDialogPrivate ValideGotoDialogPrivate;

struct _ValideGotoDialog {
	GtkWindow parent_instance;
	ValideGotoDialogPrivate * priv;
};

struct _ValideGotoDialogClass {
	GtkWindowClass parent_class;
};


ValideGotoDialog* valide_goto_dialog_construct (GType object_type, ValideAbstractTextDocument* document);
ValideGotoDialog* valide_goto_dialog_new (ValideAbstractTextDocument* document);
void valide_goto_dialog_show (ValideGotoDialog* self);
ValideAbstractTextDocument* valide_goto_dialog_get_document (ValideGotoDialog* self);
GType valide_goto_dialog_get_type (void);


G_END_DECLS

#endif
