/* plugin-manager.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __LIBVALIDE_PLUGIN_MANAGER_H__
#define __LIBVALIDE_PLUGIN_MANAGER_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_PLUGIN_MANAGER (valide_plugin_manager_get_type ())
#define VALIDE_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PLUGIN_MANAGER, ValidePluginManager))
#define VALIDE_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PLUGIN_MANAGER, ValidePluginManagerClass))
#define VALIDE_IS_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PLUGIN_MANAGER))
#define VALIDE_IS_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PLUGIN_MANAGER))
#define VALIDE_PLUGIN_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PLUGIN_MANAGER, ValidePluginManagerClass))

typedef struct _ValidePluginManager ValidePluginManager;
typedef struct _ValidePluginManagerClass ValidePluginManagerClass;
typedef struct _ValidePluginManagerPrivate ValidePluginManagerPrivate;

struct _ValidePluginManager {
	GObject parent_instance;
	ValidePluginManagerPrivate * priv;
	GList* plugins;
};

struct _ValidePluginManagerClass {
	GObjectClass parent_class;
};


ValidePluginManager* valide_plugin_manager_get_instance (void);
GtkWidget* valide_plugin_manager_preferences (ValidePluginManager* self);
void valide_plugin_manager_free (ValidePluginManager* self);
GType valide_plugin_manager_get_type (void);


G_END_DECLS

#endif
