/* project-dialog-options.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __LIBVALIDE_PROJECT_DIALOG_OPTIONS_H__
#define __LIBVALIDE_PROJECT_DIALOG_OPTIONS_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <libvalide/ui/abstract-project-dialog-options.h>
#include <libvalide/project.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_PROJECT_DIALOG_OPTIONS (valide_project_dialog_options_get_type ())
#define VALIDE_PROJECT_DIALOG_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT_DIALOG_OPTIONS, ValideProjectDialogOptions))
#define VALIDE_PROJECT_DIALOG_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT_DIALOG_OPTIONS, ValideProjectDialogOptionsClass))
#define VALIDE_IS_PROJECT_DIALOG_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT_DIALOG_OPTIONS))
#define VALIDE_IS_PROJECT_DIALOG_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT_DIALOG_OPTIONS))
#define VALIDE_PROJECT_DIALOG_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT_DIALOG_OPTIONS, ValideProjectDialogOptionsClass))

typedef struct _ValideProjectDialogOptions ValideProjectDialogOptions;
typedef struct _ValideProjectDialogOptionsClass ValideProjectDialogOptionsClass;
typedef struct _ValideProjectDialogOptionsPrivate ValideProjectDialogOptionsPrivate;

struct _ValideProjectDialogOptions {
	ValideAbstractProjectDialogOptions parent_instance;
	ValideProjectDialogOptionsPrivate * priv;
};

struct _ValideProjectDialogOptionsClass {
	ValideAbstractProjectDialogOptionsClass parent_class;
};


void valide_project_dialog_options_add_vapi_dir (GtkWidget* sender, ValideProjectDialogOptions* self);
void valide_project_dialog_options_del_vapi_dir (GtkButton* sender, ValideProjectDialogOptions* self);
void valide_project_dialog_options_update_vapi (ValideProjectDialogOptions* self);
void valide_project_dialog_options_add_pkg (GtkButton* sender, ValideProjectDialogOptions* self);
void valide_project_dialog_options_del_pkg (GtkButton* sender, ValideProjectDialogOptions* self);
ValideProjectDialogOptions* valide_project_dialog_options_construct (GType object_type, ValideProject* project);
ValideProjectDialogOptions* valide_project_dialog_options_new (ValideProject* project);
gint valide_project_dialog_options_run (ValideProjectDialogOptions* self);
void valide_project_dialog_options_destroy (ValideProjectDialogOptions* self);
const char* valide_project_dialog_options_get_path (ValideProjectDialogOptions* self);
void valide_project_dialog_options_set_path (ValideProjectDialogOptions* self, const char* value);
const char* valide_project_dialog_options_get_name (ValideProjectDialogOptions* self);
void valide_project_dialog_options_set_name (ValideProjectDialogOptions* self, const char* value);
const char* valide_project_dialog_options_get_author (ValideProjectDialogOptions* self);
void valide_project_dialog_options_set_author (ValideProjectDialogOptions* self, const char* value);
const char* valide_project_dialog_options_get_license (ValideProjectDialogOptions* self);
void valide_project_dialog_options_set_license (ValideProjectDialogOptions* self, const char* value);
const char* valide_project_dialog_options_get_version (ValideProjectDialogOptions* self);
void valide_project_dialog_options_set_version (ValideProjectDialogOptions* self, const char* value);
gboolean valide_project_dialog_options_get_debug (ValideProjectDialogOptions* self);
void valide_project_dialog_options_set_debug (ValideProjectDialogOptions* self, gboolean value);
gboolean valide_project_dialog_options_get_thread (ValideProjectDialogOptions* self);
void valide_project_dialog_options_set_thread (ValideProjectDialogOptions* self, gboolean value);
gboolean valide_project_dialog_options_get_disable_assert (ValideProjectDialogOptions* self);
void valide_project_dialog_options_set_disable_assert (ValideProjectDialogOptions* self, gboolean value);
gboolean valide_project_dialog_options_get_disable_checking (ValideProjectDialogOptions* self);
void valide_project_dialog_options_set_disable_checking (ValideProjectDialogOptions* self, gboolean value);
gboolean valide_project_dialog_options_get_disable_non_null (ValideProjectDialogOptions* self);
void valide_project_dialog_options_set_disable_non_null (ValideProjectDialogOptions* self, gboolean value);
gboolean valide_project_dialog_options_get_save_temps (ValideProjectDialogOptions* self);
void valide_project_dialog_options_set_save_temps (ValideProjectDialogOptions* self, gboolean value);
gboolean valide_project_dialog_options_get_quiet (ValideProjectDialogOptions* self);
void valide_project_dialog_options_set_quiet (ValideProjectDialogOptions* self, gboolean value);
char* valide_project_dialog_options_get_other (ValideProjectDialogOptions* self);
void valide_project_dialog_options_set_other (ValideProjectDialogOptions* self, const char* value);
GList* valide_project_dialog_options_get_vapi_dir (ValideProjectDialogOptions* self);
void valide_project_dialog_options_set_vapi_dir (ValideProjectDialogOptions* self, GList* value);
GList* valide_project_dialog_options_get_pkg (ValideProjectDialogOptions* self);
void valide_project_dialog_options_set_pkg (ValideProjectDialogOptions* self, GList* value);
ValideProject* valide_project_dialog_options_get_project (ValideProjectDialogOptions* self);
GType valide_project_dialog_options_get_type (void);


G_END_DECLS

#endif
