/* project-dialog.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __LIBVALIDE_PROJECT_DIALOG_H__
#define __LIBVALIDE_PROJECT_DIALOG_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <libvalide/ui/abstract-project-dialog.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_COLUMN_TYPE (valide_column_type_get_type ())

#define VALIDE_TYPE_PROJECT_DIALOG (valide_project_dialog_get_type ())
#define VALIDE_PROJECT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT_DIALOG, ValideProjectDialog))
#define VALIDE_PROJECT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT_DIALOG, ValideProjectDialogClass))
#define VALIDE_IS_PROJECT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT_DIALOG))
#define VALIDE_IS_PROJECT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT_DIALOG))
#define VALIDE_PROJECT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT_DIALOG, ValideProjectDialogClass))

typedef struct _ValideProjectDialog ValideProjectDialog;
typedef struct _ValideProjectDialogClass ValideProjectDialogClass;
typedef struct _ValideProjectDialogPrivate ValideProjectDialogPrivate;

typedef enum  {
	VALIDE_COLUMN_TYPE_ICON,
	VALIDE_COLUMN_TYPE_NAME,
	VALIDE_COLUMN_TYPE_DESCRIPTION,
	VALIDE_COLUMN_TYPE_PATH,
	VALIDE_COLUMN_TYPE_NB_COLUMNS
} ValideColumnType;

struct _ValideProjectDialog {
	ValideAbstractProjectDialog parent_instance;
	ValideProjectDialogPrivate * priv;
};

struct _ValideProjectDialogClass {
	ValideAbstractProjectDialogClass parent_class;
};


GType valide_column_type_get_type (void);
void valide_project_dialog_selection_changed (GtkIconView* icon_view, ValideProjectDialog* self);
void valide_project_dialog_project_path_change (GtkWidget* sender, ValideProjectDialog* self);
void valide_project_dialog_show (ValideProjectDialog* self);
guint valide_project_dialog_run (ValideProjectDialog* self);
ValideProjectDialog* valide_project_dialog_construct (GType object_type);
ValideProjectDialog* valide_project_dialog_new (void);
char* valide_project_dialog_get_project_name (ValideProjectDialog* self);
char* valide_project_dialog_get_project_author (ValideProjectDialog* self);
char* valide_project_dialog_get_project_version (ValideProjectDialog* self);
char* valide_project_dialog_get_project_license (ValideProjectDialog* self);
char* valide_project_dialog_get_project_dir (ValideProjectDialog* self);
char* valide_project_dialog_get_project_path (ValideProjectDialog* self);
char* valide_project_dialog_get_template (ValideProjectDialog* self);
void valide_project_dialog_set_project_desc (ValideProjectDialog* self, const char* value);
GType valide_project_dialog_get_type (void);


G_END_DECLS

#endif
