/* searching.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __LIBVALIDE_SEARCHING_H__
#define __LIBVALIDE_SEARCHING_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <libvalide/abstract-text-document.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_SEARCHING (valide_searching_get_type ())
#define VALIDE_SEARCHING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_SEARCHING, ValideSearching))
#define VALIDE_SEARCHING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_SEARCHING, ValideSearchingClass))
#define VALIDE_IS_SEARCHING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_SEARCHING))
#define VALIDE_IS_SEARCHING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_SEARCHING))
#define VALIDE_SEARCHING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_SEARCHING, ValideSearchingClass))

typedef struct _ValideSearching ValideSearching;
typedef struct _ValideSearchingClass ValideSearchingClass;
typedef struct _ValideSearchingPrivate ValideSearchingPrivate;

struct _ValideSearching {
	GtkVBox parent_instance;
	ValideSearchingPrivate * priv;
};

struct _ValideSearchingClass {
	GtkVBoxClass parent_class;
};


ValideSearching* valide_searching_construct (GType object_type, ValideAbstractTextDocument* document);
ValideSearching* valide_searching_new (ValideAbstractTextDocument* document);
void valide_searching_find (ValideSearching* self, gboolean show_dialog);
void valide_searching_find_next (ValideSearching* self);
void valide_searching_find_prev (ValideSearching* self);
void valide_searching_show (ValideSearching* self);
ValideAbstractTextDocument* valide_searching_get_document (ValideSearching* self);
const char* valide_searching_get_text (ValideSearching* self);
void valide_searching_set_text (ValideSearching* self, const char* value);
gboolean valide_searching_get_casse (ValideSearching* self);
void valide_searching_set_casse (ValideSearching* self, gboolean value);
gboolean valide_searching_get_word (ValideSearching* self);
void valide_searching_set_word (ValideSearching* self, gboolean value);
GType valide_searching_get_type (void);


G_END_DECLS

#endif
