/* split-source-view.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __LIBVALIDE_SPLIT_SOURCE_VIEW_H__
#define __LIBVALIDE_SPLIT_SOURCE_VIEW_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <libvalide/source-view.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_SPLIT_SOURCE_VIEW (valide_split_source_view_get_type ())
#define VALIDE_SPLIT_SOURCE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_SPLIT_SOURCE_VIEW, ValideSplitSourceView))
#define VALIDE_SPLIT_SOURCE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_SPLIT_SOURCE_VIEW, ValideSplitSourceViewClass))
#define VALIDE_IS_SPLIT_SOURCE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_SPLIT_SOURCE_VIEW))
#define VALIDE_IS_SPLIT_SOURCE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_SPLIT_SOURCE_VIEW))
#define VALIDE_SPLIT_SOURCE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_SPLIT_SOURCE_VIEW, ValideSplitSourceViewClass))

typedef struct _ValideSplitSourceView ValideSplitSourceView;
typedef struct _ValideSplitSourceViewClass ValideSplitSourceViewClass;
typedef struct _ValideSplitSourceViewPrivate ValideSplitSourceViewPrivate;

struct _ValideSplitSourceView {
	GtkVPaned parent_instance;
	ValideSplitSourceViewPrivate * priv;
};

struct _ValideSplitSourceViewClass {
	GtkVPanedClass parent_class;
};


ValideSplitSourceView* valide_split_source_view_construct (GType object_type, const char* language);
ValideSplitSourceView* valide_split_source_view_new (const char* language);
ValideSourceView* valide_split_source_view_get_active_view (ValideSplitSourceView* self);
ValideSourceView* valide_split_source_view_get_view1 (ValideSplitSourceView* self);
ValideSourceView* valide_split_source_view_get_view2 (ValideSplitSourceView* self);
GType valide_split_source_view_get_type (void);


G_END_DECLS

#endif
