/* start-page.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __LIBVALIDE_START_PAGE_H__
#define __LIBVALIDE_START_PAGE_H__

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <libvalide/idocument.h>

G_BEGIN_DECLS


#define VALIDE_TYPE_LINK_LABEL (valide_link_label_get_type ())
#define VALIDE_LINK_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_LINK_LABEL, ValideLinkLabel))
#define VALIDE_LINK_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_LINK_LABEL, ValideLinkLabelClass))
#define VALIDE_IS_LINK_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_LINK_LABEL))
#define VALIDE_IS_LINK_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_LINK_LABEL))
#define VALIDE_LINK_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_LINK_LABEL, ValideLinkLabelClass))

typedef struct _ValideLinkLabel ValideLinkLabel;
typedef struct _ValideLinkLabelClass ValideLinkLabelClass;
typedef struct _ValideLinkLabelPrivate ValideLinkLabelPrivate;

#define VALIDE_TYPE_START_PAGE (valide_start_page_get_type ())
#define VALIDE_START_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_START_PAGE, ValideStartPage))
#define VALIDE_START_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_START_PAGE, ValideStartPageClass))
#define VALIDE_IS_START_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_START_PAGE))
#define VALIDE_IS_START_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_START_PAGE))
#define VALIDE_START_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_START_PAGE, ValideStartPageClass))

typedef struct _ValideStartPage ValideStartPage;
typedef struct _ValideStartPageClass ValideStartPageClass;
typedef struct _ValideStartPagePrivate ValideStartPagePrivate;

struct _ValideLinkLabel {
	GtkEventBox parent_instance;
	ValideLinkLabelPrivate * priv;
};

struct _ValideLinkLabelClass {
	GtkEventBoxClass parent_class;
};

struct _ValideStartPage {
	GtkTable parent_instance;
	ValideStartPagePrivate * priv;
};

struct _ValideStartPageClass {
	GtkTableClass parent_class;
};


ValideLinkLabel* valide_link_label_construct (GType object_type, const char* uri, const char* title);
ValideLinkLabel* valide_link_label_new (const char* uri, const char* title);
const char* valide_link_label_get_uri (ValideLinkLabel* self);
GType valide_link_label_get_type (void);
ValideStartPage* valide_start_page_construct (GType object_type);
ValideStartPage* valide_start_page_new (void);
GType valide_start_page_get_type (void);


G_END_DECLS

#endif
