/* proposal.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __PLUGINS_COMPLETION_SOURCE_COMPLETION_PROPOSAL_H__
#define __PLUGINS_COMPLETION_SOURCE_COMPLETION_PROPOSAL_H__

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gtk/gtk.h>

G_BEGIN_DECLS


#define SOURCE_COMPLETION_TYPE_PROPOSAL (source_completion_proposal_get_type ())
#define SOURCE_COMPLETION_PROPOSAL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOURCE_COMPLETION_TYPE_PROPOSAL, SourceCompletionProposal))
#define SOURCE_COMPLETION_PROPOSAL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOURCE_COMPLETION_TYPE_PROPOSAL, SourceCompletionProposalClass))
#define SOURCE_COMPLETION_IS_PROPOSAL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOURCE_COMPLETION_TYPE_PROPOSAL))
#define SOURCE_COMPLETION_IS_PROPOSAL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOURCE_COMPLETION_TYPE_PROPOSAL))
#define SOURCE_COMPLETION_PROPOSAL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOURCE_COMPLETION_TYPE_PROPOSAL, SourceCompletionProposalClass))

typedef struct _SourceCompletionProposal SourceCompletionProposal;
typedef struct _SourceCompletionProposalClass SourceCompletionProposalClass;
typedef struct _SourceCompletionProposalPrivate SourceCompletionProposalPrivate;

/*
 * This code is re-writing in the vala language of GtkSourceCompletion
 *
 * Copyright (C) 2008 - ChuchiPerriman
 *
 * rev 163
 */
struct _SourceCompletionProposal {
	GObject parent_instance;
	SourceCompletionProposalPrivate * priv;
};

struct _SourceCompletionProposalClass {
	GObjectClass parent_class;
};


#define SOURCE_COMPLETION_PROPOSAL_DEFAULT_PAGE "Default"
SourceCompletionProposal* source_completion_proposal_construct (GType object_type, const char* label, const char* info, GdkPixbuf* icon);
SourceCompletionProposal* source_completion_proposal_new (const char* label, const char* info, GdkPixbuf* icon);
const char* source_completion_proposal_get_label (SourceCompletionProposal* self);
void source_completion_proposal_set_label (SourceCompletionProposal* self, const char* value);
const char* source_completion_proposal_get_info (SourceCompletionProposal* self);
void source_completion_proposal_set_info (SourceCompletionProposal* self, const char* value);
GdkPixbuf* source_completion_proposal_get_icon (SourceCompletionProposal* self);
void source_completion_proposal_set_icon (SourceCompletionProposal* self, GdkPixbuf* value);
const char* source_completion_proposal_get_page_name (SourceCompletionProposal* self);
void source_completion_proposal_set_page_name (SourceCompletionProposal* self, const char* value);
GType source_completion_proposal_get_type (void);


G_END_DECLS

#endif
