/* opened-documents.vala
 *
 * Copyright (C) 2009 Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <gege2061@redaction-developpez.com>
 */

#ifndef __PLUGINS_OPENED_DOCUMENTS_OPENED_DOCUMENTS_H__
#define __PLUGINS_OPENED_DOCUMENTS_OPENED_DOCUMENTS_H__

#include <glib.h>
#include <glib-object.h>
#include <libvalide/plugin.h>

G_BEGIN_DECLS


#define TYPE_OPENED_DOCUMENTS (opened_documents_get_type ())
#define OPENED_DOCUMENTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_OPENED_DOCUMENTS, OpenedDocuments))
#define OPENED_DOCUMENTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_OPENED_DOCUMENTS, OpenedDocumentsClass))
#define IS_OPENED_DOCUMENTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_OPENED_DOCUMENTS))
#define IS_OPENED_DOCUMENTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_OPENED_DOCUMENTS))
#define OPENED_DOCUMENTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_OPENED_DOCUMENTS, OpenedDocumentsClass))

typedef struct _OpenedDocuments OpenedDocuments;
typedef struct _OpenedDocumentsClass OpenedDocumentsClass;
typedef struct _OpenedDocumentsPrivate OpenedDocumentsPrivate;

struct _OpenedDocuments {
	ValidePlugin parent_instance;
	OpenedDocumentsPrivate * priv;
};

struct _OpenedDocumentsClass {
	ValidePluginClass parent_class;
};


OpenedDocuments* opened_documents_construct (GType object_type);
OpenedDocuments* opened_documents_new (void);
GType opened_documents_get_type (void);
GType register_plugin (void);


G_END_DECLS

#endif
