/* completion.vapi generated by valac, do not modify. */

[CCode (cprefix = "Completion", lower_case_cprefix = "completion_")]
namespace Completion {
	[CCode (ref_function = "completion_filter_options_ref", unref_function = "completion_filter_options_unref", param_spec_function = "completion_param_spec_filter_options", cheader_filename = "plugins/completion/vala-provider.h")]
	public class FilterOptions {
		public string exclude_type;
		public bool interface_symbols;
		public bool internal_symbols;
		public bool only_constructors;
		public bool private_symbols;
		public bool protected_symbols;
		public bool public_symbols;
		public bool static_symbols;
		public FilterOptions ();
		public void public_only ();
	}
	[CCode (cheader_filename = "plugins/completion/item.h")]
	public class Item : GLib.Object {
		public string info;
		public int line;
		public string name;
		public string type_name;
		public Item (string name);
		public Item.with_class (Vala.Class item);
		public Item.with_field (Vala.Field item);
		public Item.with_interface (Vala.Interface item);
		public Item.with_method (Vala.Method item);
		public Item.with_property (Vala.Property item);
		public Item.with_signal (Vala.Signal item);
		public Item.with_struct (Vala.Struct item);
	}
	[CCode (cheader_filename = "plugins/completion/parser.h")]
	public class Parser : GLib.Object {
		public bool add_package (string name);
		public bool add_source (string uri);
		public bool add_vapidir (string uri);
		public Completion.Result get_completions_for_name (Completion.FilterOptions options, string symbolname, string? sourcefile = null) throws GLib.Error;
		public Parser ();
		public void parse_context (Vala.CodeContext context);
		public bool remove_package (string name);
		public bool remove_source (string uri);
		public bool remove_vapidir (string uri);
	}
	[CCode (cheader_filename = "plugins/completion/result.h")]
	public class Result : GLib.Object {
		public Gee.List<Completion.Item> classes;
		public Gee.List<Completion.Item> constants;
		public Gee.List<Completion.Item> enums;
		public Gee.List<Completion.Item> fields;
		public Gee.List<Completion.Item> interfaces;
		public Gee.List<Completion.Item> methods;
		public Gee.List<Completion.Item> namespaces;
		public Gee.List<Completion.Item> others;
		public Gee.List<Completion.Item> properties;
		public Gee.List<Completion.Item> signals;
		public Gee.List<Completion.Item> structs;
		public bool classes_contain (string name);
		public bool constants_contain (string name);
		public bool enums_contain (string name);
		public bool interfaces_contain (string name);
		public bool namespaces_contain (string name);
		public Result ();
		public bool structs_contain (string name);
		public int count { get; }
		public bool is_empty { get; }
	}
	[CCode (cheader_filename = "plugins/completion/source-buffer.h")]
	public class SourceBuffer : GLib.Object {
		public SourceBuffer (string name, string? source);
		public void* data { get; set; }
		public string name { get; construct; }
		public string source { get; construct; }
	}
	[CCode (cheader_filename = "plugins/completion/vala-provider.h")]
	public class ValaProvider : GLib.Object, SourceCompletion.Provider {
		public ValaProvider (Gtk.TextView text_view);
		public Gtk.TextView text_view { get; construct; }
	}
}
[CCode (cprefix = "SourceCompletion", lower_case_cprefix = "source_completion_")]
namespace SourceCompletion {
	[CCode (cheader_filename = "plugins/completion/source-completion/documentwords-provider.h")]
	public class DocumentwordsProvider : GLib.Object, SourceCompletion.Provider {
		[CCode (cprefix = "SOURCE_COMPLETION_DOCUMENTWORDS_PROVIDER_SORT_TYPE_", cheader_filename = "plugins/completion/source-completion/documentwords-provider.h")]
		public enum SortType {
			NONE,
			BY_LENGTH
		}
		public virtual void finish ();
		public virtual string get_name ();
		public virtual GLib.List? get_proposals (SourceCompletion.Trigger trigger);
		public DocumentwordsProvider (Gtk.TextView view);
		public bool pred_is_separator (unichar ch);
		public static int utf8_len_compare (void* a, void* b);
		public SourceCompletion.DocumentwordsProvider.SortType sort_type { get; set; }
		public Gtk.TextView view { get; construct; }
	}
	[CCode (cheader_filename = "plugins/completion/source-completion/info.h")]
	public class Info : Gtk.Window {
		[CCode (cprefix = "SOURCE_COMPLETION_INFO_INFO_TYPE_", cheader_filename = "plugins/completion/source-completion/info.h")]
		public enum InfoType {
			VIEW_SORT,
			VIEW_EXTENDED
		}
		public void hide ();
		public void move_to_cursor (Gtk.TextView view);
		public Info ();
		public void set_adjust_height (bool adjust, int max_height);
		public void set_adjust_width (bool adjust, int max_width);
		public void set_info_type (SourceCompletion.Info.InfoType type);
		public void set_markup (string markup);
		public void show ();
		public signal void info_type_changed (SourceCompletion.Info.InfoType type);
	}
	[CCode (cheader_filename = "plugins/completion/source-completion/manager.h")]
	public class Manager : GLib.Object {
		[CCode (ref_function = "source_completion_manager_event_options_ref", unref_function = "source_completion_manager_event_options_unref", param_spec_function = "source_completion_manager_param_spec_event_options", cheader_filename = "plugins/completion/source-completion/manager.h")]
		public class EventOptions {
			public bool autoselect;
			public string filter_text;
			public SourceCompletion.Popup.FilterType filter_type;
			public SourceCompletion.Popup.PositionType position_type;
			public bool show_bottom_bar;
			public EventOptions ();
		}
		public const string USER_REQUEST_TRIGGER_NAME;
		public void activate ();
		public void deactivate ();
		public override void finalize ();
		public void finish_completion ();
		public SourceCompletion.Trigger get_active_trigger ();
		public void get_current_event_options (out SourceCompletion.Manager.EventOptions options);
		public static SourceCompletion.Manager get_from_view (Gtk.TextView view);
		public static SourceCompletion.Manager get_instance (Gtk.TextView view);
		public SourceCompletion.Provider? get_provider (string provider_name);
		public SourceCompletion.Trigger? get_trigger (string trigger_name);
		public Gtk.TextView get_view ();
		public bool is_visible ();
		public bool register_provider (SourceCompletion.Provider provider, string trigger_name);
		public void register_trigger (SourceCompletion.Trigger trigger);
		public void set_current_info (string info);
		public void trigger_event (string trigger_name, void* event_data);
		public void trigger_event_with_opts (string trigger_name, SourceCompletion.Manager.EventOptions? options, void* event_data);
		public bool unregister_provider (SourceCompletion.Provider provider, string trigger_name);
		public void unregister_trigger (SourceCompletion.Trigger trigger);
		public void update_event_options (SourceCompletion.Manager.EventOptions? options);
		public string info_keys { owned get; set; }
		public string next_page_keys { owned get; set; }
		public string previous_page_keys { owned get; set; }
	}
	[CCode (cheader_filename = "plugins/completion/source-completion/popup.h")]
	public class Popup : Gtk.Window {
		[CCode (cprefix = "SOURCE_COMPLETION_POPUP_FILTER_TYPE_", cheader_filename = "plugins/completion/source-completion/popup.h")]
		public enum FilterType {
			NONE,
			TREE,
			TREE_HIDDEN
		}
		[CCode (cprefix = "SOURCE_COMPLETION_POPUP_KEYS_TYPE_", cheader_filename = "plugins/completion/source-completion/popup.h")]
		public enum KeysType {
			INFO,
			PAGE_NEXT,
			PAGE_PREV,
			LAST
		}
		[CCode (cprefix = "SOURCE_COMPLETION_POPUP_POSITION_TYPE_", cheader_filename = "plugins/completion/source-completion/popup.h")]
		public enum PositionType {
			CURSOR,
			CENTER_SCREEN,
			CENTER_PARENT
		}
		public void add_data (SourceCompletion.Proposal data);
		public bool bottom_bar_get_visible ();
		public void bottom_bar_set_visible (bool visible);
		public void clear ();
		public override void destroy ();
		public string get_filter_text ();
		public SourceCompletion.Popup.FilterType get_filter_type ();
		public string get_key (SourceCompletion.Popup.KeysType type);
		public int get_num_active_pages ();
		public bool get_selected_proposal (out SourceCompletion.Proposal proposal);
		public bool has_proposals ();
		public bool manage_key (Gdk.EventKey event);
		public Popup ();
		public void page_next ();
		public void page_previous ();
		public override void realize ();
		public bool select_first ();
		public bool select_last ();
		public bool select_next (int rows);
		public bool select_previous (int rows);
		public void set_current_info (string? info);
		public void set_filter_text (string text);
		public void set_filter_type (SourceCompletion.Popup.FilterType filter_type);
		public void set_key (SourceCompletion.Popup.KeysType type, string keys);
		public void show_or_update ();
		public void toggle_proposal_info ();
		public signal void display_info (SourceCompletion.Proposal proposal);
		public signal void proposal_selected (SourceCompletion.Proposal proposal);
	}
	[CCode (cheader_filename = "plugins/completion/source-completion/proposal.h")]
	public class Proposal : GLib.Object {
		public const string DEFAULT_PAGE;
		public Proposal (string label, string? info, Gdk.Pixbuf icon);
		public Gdk.Pixbuf icon { get; set construct; }
		public string info { get; set construct; }
		public string label { get; set construct; }
		public string page_name { get; set; }
		public signal bool apply (Gtk.TextView view);
	}
	[CCode (cheader_filename = "plugins/completion/source-completion/provider-file.h")]
	public class ProviderFile : GLib.Object, SourceCompletion.Provider {
		public virtual void finish ();
		public virtual string get_name ();
		public virtual GLib.List? get_proposals (SourceCompletion.Trigger trigger);
		public ProviderFile (Gtk.TextView view);
		public void set_file (string file);
		public Gtk.TextView view { get; construct; }
	}
	[CCode (cheader_filename = "plugins/completion/source-completion/tree.h")]
	public class Tree : Gtk.ScrolledWindow {
		public void add_data (SourceCompletion.Proposal data);
		public void clear ();
		public void filter (string filter);
		public int get_num_proposals ();
		public bool get_selected_proposal (out SourceCompletion.Proposal proposal);
		public Tree ();
		public bool select_first ();
		public bool select_last ();
		public bool select_next (int rows);
		public bool select_previous (int rows);
		public signal void proposal_selected (SourceCompletion.Proposal proposal);
		public signal void selection_changed (SourceCompletion.Proposal proposal);
	}
	[CCode (cheader_filename = "plugins/completion/source-completion/trigger-autowords.h")]
	public class TriggerAutowords : GLib.Object, SourceCompletion.Trigger {
		public const string NAME;
		public TriggerAutowords (SourceCompletion.Manager completion);
		public void set_delay (uint delay);
		public SourceCompletion.Manager completion { get; construct; }
	}
	[CCode (cheader_filename = "plugins/completion/source-completion/trigger-customkey.h")]
	public class TriggerCustomkey : SourceCompletion.Trigger, GLib.Object {
		public TriggerCustomkey (SourceCompletion.Manager completion, string trigger_name, string keys);
		public void set_keys (string keys);
		public void set_opts (SourceCompletion.Manager.EventOptions? options);
		public SourceCompletion.Manager completion { get; construct; }
	}
	[CCode (ref_function = "source_completion_utils_ref", unref_function = "source_completion_utils_unref", param_spec_function = "source_completion_param_spec_utils", cheader_filename = "plugins/completion/source-completion/utils.h")]
	public class Utils {
		public static bool char_is_separator (unichar ch);
		public static string? clear_word (string word);
		public static bool compare_keys (uint key, uint mods, Gdk.EventKey event);
		public static string? compute_line_indentation (Gtk.TextView view, Gtk.TextIter cur);
		public static void get_cursor_pos (Gtk.TextView text_view, out int x, out int y);
		public static string get_last_word (Gtk.TextView text_view);
		public static string get_last_word_and_iter (Gtk.TextView text_view, out Gtk.TextIter start_word, out Gtk.TextIter end_word);
		public static string get_last_word_cleaned (Gtk.TextView view);
		public static string get_text (Gtk.TextView text_view);
		public static string get_text_with_indent (string content, string indent);
		public static void get_window_position_center_parent (Gtk.Window window, Gtk.Widget parent, out int x, out int y);
		public static void get_window_position_center_screen (Gtk.Window window, out int x, out int y);
		public static bool get_window_position_in_cursor (Gtk.Window window, Gtk.TextView view, out int x, out int y);
		public static void insert_text_with_indent (Gtk.TextView view, string text);
		public static bool is_valid_word (string? current_word, string? completion_word);
		public Utils ();
		public static void replace_actual_word (Gtk.TextView text_view, string text);
	}
	[CCode (cheader_filename = "plugins/completion/source-completion/provider.h")]
	public interface Provider : GLib.Object {
		public abstract void finish ();
		public abstract string get_name ();
		public abstract GLib.List? get_proposals (SourceCompletion.Trigger trigger);
	}
	[CCode (cheader_filename = "plugins/completion/source-completion/trigger.h")]
	public interface Trigger : GLib.Object {
		public abstract bool activate ();
		public abstract bool deactivate ();
		public abstract string get_name ();
	}
}
[CCode (cheader_filename = "plugins/completion/completion.h")]
public class CompletionPlugin : Valide.Plugin {
	public CompletionPlugin ();
}
[CCode (cheader_filename = "plugins/completion/completion.h")]
public static GLib.Type register_plugin ();
