/* result.vala
 *
 * Copyright (C) 2008  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *   Nicolas Joseph <gege2061@redaction-developpez.com>
 */

/*
 *  Vala symbol completion library
 *  
 *  Copyright (C) 2008 - Andrea Del Signore <sejerpz@tin.it>
 */

public class Completion.Result : Object
{
  public Gee.List<Item> properties = new Gee.ArrayList<Item> ();
  public Gee.List<Item> classes = new Gee.ArrayList<Item> ();
  public Gee.List<Item> interfaces = new Gee.ArrayList<Item> ();
  public Gee.List<Item> structs = new Gee.ArrayList<Item> ();
  public Gee.List<Item> methods = new Gee.ArrayList<Item> ();
  public Gee.List<Item> fields = new Gee.ArrayList<Item> ();
  public Gee.List<Item> signals = new Gee.ArrayList<Item> ();
  public Gee.List<Item> others = new Gee.ArrayList<Item> ();
  public Gee.List<Item> namespaces = new Gee.ArrayList<Item> ();
  public Gee.List<Item> enums = new Gee.ArrayList<Item> ();
  public Gee.List<Item> constants = new Gee.ArrayList<Item> ();

  public bool is_empty
  {
    get
    {
      return this.count == 0;
    }
  }

  public int count
  {
    get
    {
      return this.properties.size
          + this.classes.size
          + this.interfaces.size
          + this.structs.size
          + this.methods.size
          + this.fields.size
          + this.signals.size
          + this.namespaces.size
          + this.enums.size
          + this.constants.size
          + this.others.size;
    }
  }

  public bool namespaces_contain (string name)
  {
    return this.symbols_contain (this.namespaces, name);
  }

  public bool classes_contain (string name) 
  {
    return this.symbols_contain (this.classes, name);
  }

  public bool interfaces_contain (string name)
  {
    return this.symbols_contain (this.interfaces, name);
  }

  public bool structs_contain (string name)
  {
    return this.symbols_contain (this.structs, name);
  }

  public bool constants_contain (string name)
  {
    return this.symbols_contain (this.constants, name);
  }

  public bool enums_contain (string name)
  {
    return this.symbols_contain (this.enums, name);
  }

  private bool symbols_contain (Gee.List<Item> data, string name)
  {
    if (data.size == 0)
    {
      return false;
    }

    foreach (Item item in data)
    {
      if (item.name == name)
      {
        return true;
      }
    }

    return false;
  }
}

