using Valide;

public void add_utils_tests ()
{
  Test.add_func ("/valide/utils/str_replace", () => {
      try
      {
        string result;

        result = Utils.str_replace ("toto", "o", "a");
        assert (result == "tata");

/*
        result = Utils.str_replace ("t/t/", "/", "\\");
        assert (result == "t\\t\\");
*/
      }
      catch (RegexError e)
      {
        assert_not_reached ();
      }
    }
  );

  Test.add_func ("/valide/utils/get_relative_path", () => {
      string result;

      result = Utils.get_relative_path ("/home/gege2061/test", "/home/gege2061");
      assert (result == "test");

      result = Utils.get_relative_path ("/home/gege2061/test", "/home/toto");
      assert (result == "/home/gege2061/test");
    }
  );

  Test.add_func ("/valide/utils/get_extension", () => {
      string result;

      result = Utils.get_extension ("main.vala");
      assert (result == "vala");

      result = Utils.get_extension ("main.c.vala");
      assert (result == "vala");

      result = Utils.get_extension ("main");
      assert (result == null);
    }
  );

  Test.add_func ("/valide/utils/get_mtime", () => {
      uint64 result;

      try
      {
        result = Utils.get_mtime ("src/main.vala");
        assert (result > 0);
      }
      catch (Error e)
      {
        assert_not_reached ();
      }
      try
      {
        result = Utils.get_mtime ("unknow_file");
        assert_not_reached ();
      }
      catch (Error e)
      {
      }
    }
  );

  Test.add_func ("/valide/utils/set_up_io_channel", () => {
      /* pass */
    }
  );

  Test.add_func ("/valide/utils/chop", () => {
      string result;

      result = "test\n";
      Utils.chop (ref result);
      assert (result == "test");

      result = "test";
      Utils.chop (ref result);
      assert (result == "test");
    }
  );

  Test.add_func ("/valide/utils/create_small_button", () => {
      /* pass */
    }
  );

  Test.add_func ("/valide/utils/create_small_button_from_stock", () => {
      /* pass */
    }
  );

  Test.add_func ("/valide/utils/get_pixbuf_for_theme", () => {
      /* pass */
    }
  );

  Test.add_func ("/valide/utils/get_mime_type", () => {
      string result;

      try
      {
        result = Utils.get_mime_type ("src/main.vala");
        if (Config.OS == "win32")
        {
          assert (result == "application/x-ext-vala");
        }
        else
        {
          assert (result == "text/x-vala");
        }
      }
      catch (Error e)
      {
        assert_not_reached ();
      }

      try
      {
        result = Utils.get_mime_type ("unknow_file");
        assert_not_reached ();
      }
      catch (Error e)
      {
      }
    }
  );
}
